//########## Big Rockets

//### Effects

datablock ParticleData(gc_fireworkBigRedParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = 1;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 2500;
  lifetimeVarianceMS = 500;
  textureName = "base/lighting/flare";
  spinSpeed = 10;
  spinRandomMin = -10;
  spinRandomMax = 10;
  colors[0] = "1 0.2 0.1 1";
  colors[1] = "1 0 0 1";
  colors[2] = "1 0 0 0.5";
  sizes[0] = 20;
  sizes[1] = 10;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.05;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkBigRedEmitter)
{
  uiName = "";
  lifetimeMS = 150;
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 35;
  velocityVariance = 15;
  ejectionOffset = 1;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = true;
  useEmitterColors = false;
  orientParticles = false;
  particles = "gc_fireworkBigRedParticle";
};

datablock ParticleData(gc_fireworkBigOrangeParticle : gc_fireworkBigRedParticle)
{
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0.5 0 1";
  colors[2] = "1 0.5 0 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkBigOrangeEmitter : gc_fireworkBigRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkBigOrangeParticle";
};

datablock ParticleData(gc_fireworkBigYellowParticle : gc_fireworkBigRedParticle)
{
  colors[0] = "1 1 0.5 1";
  colors[1] = "1 1 0 1";
  colors[2] = "1 1 0 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkBigYellowEmitter : gc_fireworkBigRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkBigYellowParticle";
};

datablock ParticleData(gc_fireworkBigGreenParticle : gc_fireworkBigRedParticle)
{
  colors[0] = "0.2 1 0.2 1";
  colors[1] = "0 1 0 1";
  colors[2] = "0 1 0 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkBigGreenEmitter : gc_fireworkBigRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkBigGreenParticle";
};

datablock ParticleData(gc_fireworkBigCyanParticle : gc_fireworkBigRedParticle)
{
  colors[0] = "0.5 1 1 1";
  colors[1] = "0 1 1 1";
  colors[2] = "0 1 1 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkBigCyanEmitter : gc_fireworkBigRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkBigCyanParticle";
};

datablock ParticleData(gc_fireworkBigBlueParticle : gc_fireworkBigRedParticle)
{
  colors[0] = "0.1 0.2 1 1";
  colors[1] = "0 0 1 1";
  colors[2] = "0 0 1 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkBigBlueEmitter : gc_fireworkBigRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkBigBlueParticle";
};

datablock ParticleData(gc_fireworkBigPurpleParticle : gc_fireworkBigRedParticle)
{
  colors[0] = "0.6 0.2 1 1";
  colors[1] = "0.5 0 1 1";
  colors[2] = "0.5 0 1 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkBigPurpleEmitter : gc_fireworkBigRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkBigPurpleParticle";
};

datablock ParticleData(gc_fireworkBigWhiteParticle : gc_fireworkBigRedParticle)
{
  colors[0] = "1 1 1 1";
  colors[1] = "1 1 1 1";
  colors[2] = "1 1 1 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkBigWhiteEmitter : gc_fireworkBigRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkBigWhiteParticle";
};

datablock ParticleData(gc_fireworkBigRainbowParticle : gc_fireworkBigRedParticle)
{
  colors[0] = "1 0 0 1";
  colors[1] = "1 1 0 0.8";
  colors[2] = "0 1 0.5 0.6";
  colors[3] = "0 0 1 0.4";
  times[0] = 0;
  times[1] = 0.33;
  times[2] = 0.66;
  times[3] = 10;
  sizes[0] = 8;
  sizes[1] = 6;
  sizes[2] = 4;
  sizes[3] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkBigRainbowEmitter : gc_fireworkBigRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkBigRainbowParticle";
};

datablock ExplosionData(gc_fireworkBigRedExplosion)
{
  lifeTimeMS = 150;
  emitter[0] = gc_fireworkBigRedEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  damageRadius = 6;
  radiusDamage = 100;
  impulseRadius = 8;
  impulseForce = 25;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 10;
};

datablock ExplosionData(gc_fireworkBigOrangeExplosion : gc_fireworkBigRedExplosion) { emitter[0] = gc_fireworkBigOrangeEmitter; };
datablock ExplosionData(gc_fireworkBigYellowExplosion : gc_fireworkBigRedExplosion) { emitter[0] = gc_fireworkBigYellowEmitter; };
datablock ExplosionData(gc_fireworkBigGreenExplosion : gc_fireworkBigRedExplosion) { emitter[0] = gc_fireworkBigGreenEmitter; };
datablock ExplosionData(gc_fireworkBigCyanExplosion : gc_fireworkBigRedExplosion) { emitter[0] = gc_fireworkBigCyanEmitter; };
datablock ExplosionData(gc_fireworkBigBlueExplosion : gc_fireworkBigRedExplosion) { emitter[0] = gc_fireworkBigBlueEmitter; };
datablock ExplosionData(gc_fireworkBigPurpleExplosion : gc_fireworkBigRedExplosion) { emitter[0] = gc_fireworkBigPurpleEmitter; };
datablock ExplosionData(gc_fireworkBigWhiteExplosion : gc_fireworkBigRedExplosion) { emitter[0] = gc_fireworkBigWhiteEmitter; };
datablock ExplosionData(gc_fireworkBigRainbow1Explosion : gc_fireworkBigRedExplosion) { emitter[0] = gc_fireworkBigRainbowEmitter; };
datablock ExplosionData(gc_fireworkBigRainbow2Explosion : gc_fireworkBigRedExplosion)
{
  emitter[0] = gc_fireworkBigRedEmitter;
  emitter[1] = gc_fireworkBigYellowEmitter;
  emitter[2] = gc_fireworkBigGreenEmitter;
  emitter[3] = gc_fireworkBigBlueEmitter;
};

//### Projectile

datablock ProjectileData(gc_fireworkBigRedProjectile)
{
  uiName = "Firework (B) Red";
  projectileShapeName = "Add-ons/Projectile_Fireworks/fireworkbig.dts";
  directDamageType = $DamageType::gc_Firework;
  radiusDamageType = $DamageType::gc_Firework;
  particleEmitter = gc_FireworkTrailEmitter;
  explosion = gc_fireworkBigRedExplosion;
  muzzleVelocity = 50;
  verInheritFactor = 1;
  lifetime = 3000;
  fadeDelay = 3000;
  armingDelay = 3000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.5;
  explodeOnDeath = true;
  explodeOnPlayerImpact = true;
  sound = gc_FuzeSound;
};

datablock ProjectileData(gc_fireworkBigOrangeProjectile : gc_fireworkBigRedProjectile)
{
  uiName = "Firework (B) Orange";
  explosion = gc_fireworkBigOrangeExplosion;
};

datablock ProjectileData(gc_fireworkBigYellowProjectile : gc_fireworkBigRedProjectile)
{
  uiName = "Firework (B) Yellow";
  explosion = gc_fireworkBigYellowExplosion;
};

datablock ProjectileData(gc_fireworkBigGreenProjectile : gc_fireworkBigRedProjectile)
{
  uiName = "Firework (B) Green";
  explosion = gc_fireworkBigGreenExplosion;
};

datablock ProjectileData(gc_fireworkBigCyanProjectile : gc_fireworkBigRedProjectile)
{
  uiName = "Firework (B) Cyan";
  explosion = gc_fireworkBigCyanExplosion;
};

datablock ProjectileData(gc_fireworkBigBlueProjectile : gc_fireworkBigRedProjectile)
{
  uiName = "Firework (B) Blue";
  explosion = gc_fireworkBigBlueExplosion;
};

datablock ProjectileData(gc_fireworkBigPurpleProjectile : gc_fireworkBigRedProjectile)
{
  uiName = "Firework (B) Purple";
  explosion = gc_fireworkBigPurpleExplosion;
};

datablock ProjectileData(gc_fireworkBigWhiteProjectile : gc_fireworkBigRedProjectile)
{
  uiName = "Firework (B) White";
  explosion = gc_fireworkBigWhiteExplosion;
};

datablock ProjectileData(gc_fireworkBigRainbow1Projectile : gc_fireworkBigRedProjectile)
{
  uiName = "Firework (B) Rainbow 1";
  explosion = gc_fireworkBigRainbow1Explosion;
};

datablock ProjectileData(gc_fireworkBigRainbow2Projectile : gc_fireworkBigRedProjectile)
{
  uiName = "Firework (B) Rainbow 2";
  explosion = gc_fireworkBigRainbow2Explosion;
};

function gc_fireworkBigRedProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkBigOrangeProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkBigYellowProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkBigGreenProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkBigCyanProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkBigBlueProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkBigPurpleProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkBigWhiteProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkBigRainbow1Projectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkBigRainbow2Projectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}
