//########## Small Rockets

//### Effects

datablock ParticleData(gc_fireworkSmallRedParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = 1;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 2000;
  lifetimeVarianceMS = 500;
  textureName = "base/lighting/flare";
  spinSpeed = 10;
  spinRandomMin = -10;
  spinRandomMax = 10;
  colors[0] = "1 0.2 0.1 1";
  colors[1] = "1 0 0 1";
  colors[2] = "1 0 0 0.5";
  sizes[0] = 10;
  sizes[1] = 5;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.05;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkSmallRedEmitter)
{
  uiName = "";
  lifetimeMS = 100;
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 25;
  velocityVariance = 10;
  ejectionOffset = 1;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = true;
  useEmitterColors = false;
  orientParticles = false;
  particles = "gc_fireworkSmallRedParticle";
};

datablock ParticleData(gc_fireworkSmallOrangeParticle : gc_fireworkSmallRedParticle)
{
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0.5 0 1";
  colors[2] = "1 0.5 0 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkSmallOrangeEmitter : gc_fireworkSmallRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkSmallOrangeParticle";
};

datablock ParticleData(gc_fireworkSmallYellowParticle : gc_fireworkSmallRedParticle)
{
  colors[0] = "1 1 0.5 1";
  colors[1] = "1 1 0 1";
  colors[2] = "1 1 0 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkSmallYellowEmitter : gc_fireworkSmallRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkSmallYellowParticle";
};

datablock ParticleData(gc_fireworkSmallGreenParticle : gc_fireworkSmallRedParticle)
{
  colors[0] = "0.2 1 0.2 1";
  colors[1] = "0 1 0 1";
  colors[2] = "0 1 0 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkSmallGreenEmitter : gc_fireworkSmallRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkSmallGreenParticle";
};

datablock ParticleData(gc_fireworkSmallCyanParticle : gc_fireworkSmallRedParticle)
{
  colors[0] = "0.5 1 1 1";
  colors[1] = "0 1 1 1";
  colors[2] = "0 1 1 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkSmallCyanEmitter : gc_fireworkSmallRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkSmallCyanParticle";
};

datablock ParticleData(gc_fireworkSmallBlueParticle : gc_fireworkSmallRedParticle)
{
  colors[0] = "0.1 0.2 1 1";
  colors[1] = "0 0 1 1";
  colors[2] = "0 0 1 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkSmallBlueEmitter : gc_fireworkSmallRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkSmallBlueParticle";
};

datablock ParticleData(gc_fireworkSmallPurpleParticle : gc_fireworkSmallRedParticle)
{
  colors[0] = "0.6 0.2 1 1";
  colors[1] = "0.5 0 1 1";
  colors[2] = "0.5 0 1 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkSmallPurpleEmitter : gc_fireworkSmallRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkSmallPurpleParticle";
};

datablock ParticleData(gc_fireworkSmallWhiteParticle : gc_fireworkSmallRedParticle)
{
  colors[0] = "1 1 1 1";
  colors[1] = "1 1 1 1";
  colors[2] = "1 1 1 0.5";
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkSmallWhiteEmitter : gc_fireworkSmallRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkSmallWhiteParticle";
};

datablock ParticleData(gc_fireworkSmallRainbowParticle : gc_fireworkSmallRedParticle)
{
  colors[0] = "1 0 0 1";
  colors[1] = "1 1 0 0.8";
  colors[2] = "0 1 0.5 0.6";
  colors[3] = "0 0 1 0.4";
  times[0] = 0;
  times[1] = 0.33;
  times[2] = 0.66;
  times[3] = 1;
  sizes[0] = 6;
  sizes[1] = 4;
  sizes[2] = 2;
  sizes[3] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkSmallRainbowEmitter : gc_fireworkSmallRedEmitter)
{
  uiName = "";
  particles = "gc_fireworkSmallRainbowParticle";
};

datablock ExplosionData(gc_fireworkSmallRedExplosion)
{
  lifeTimeMS = 100;
  emitter[0] = gc_fireworkSmallRedEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  damageRadius = 4;
  radiusDamage = 100;
  impulseRadius = 5;
  impulseForce = 25;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 6;
};

datablock ExplosionData(gc_fireworkSmallOrangeExplosion : gc_fireworkSmallRedExplosion) { emitter[0] = gc_fireworkSmallOrangeEmitter; };
datablock ExplosionData(gc_fireworkSmallYellowExplosion : gc_fireworkSmallRedExplosion) { emitter[0] = gc_fireworkSmallYellowEmitter; };
datablock ExplosionData(gc_fireworkSmallGreenExplosion : gc_fireworkSmallRedExplosion) { emitter[0] = gc_fireworkSmallGreenEmitter; };
datablock ExplosionData(gc_fireworkSmallCyanExplosion : gc_fireworkSmallRedExplosion) { emitter[0] = gc_fireworkSmallCyanEmitter; };
datablock ExplosionData(gc_fireworkSmallBlueExplosion : gc_fireworkSmallRedExplosion) { emitter[0] = gc_fireworkSmallBlueEmitter; };
datablock ExplosionData(gc_fireworkSmallPurpleExplosion : gc_fireworkSmallRedExplosion) { emitter[0] = gc_fireworkSmallPurpleEmitter; };
datablock ExplosionData(gc_fireworkSmallWhiteExplosion : gc_fireworkSmallRedExplosion) { emitter[0] = gc_fireworkSmallWhiteEmitter; };
datablock ExplosionData(gc_fireworkSmallRainbow1Explosion : gc_fireworkSmallRedExplosion) { emitter[0] = gc_fireworkSmallRainbowEmitter; };
datablock ExplosionData(gc_fireworkSmallRainbow2Explosion : gc_fireworkSmallRedExplosion)
{
  emitter[0] = gc_fireworkSmallRedEmitter;
  emitter[1] = gc_fireworkSmallYellowEmitter;
  emitter[2] = gc_fireworkSmallGreenEmitter;
  emitter[3] = gc_fireworkSmallBlueEmitter;
};

//### Projectile

datablock ProjectileData(gc_fireworkSmallRedProjectile)
{
  uiName = "Firework (S) Red";
  projectileShapeName = "Add-ons/Projectile_Fireworks/firework.dts";
  directDamageType = $DamageType::gc_Firework;
  radiusDamageType = $DamageType::gc_Firework;
  particleEmitter = gc_FireworkTrailEmitter;
  explosion = gc_fireworkSmallRedExplosion;
  muzzleVelocity = 50;
  verInheritFactor = 1;
  lifetime = 3000;
  fadeDelay = 3000;
  armingDelay = 3000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.5;
  explodeOnDeath = true;
  explodeOnPlayerImpact = true;
  sound = gc_FuzeSound;
};

datablock ProjectileData(gc_fireworkSmallOrangeProjectile : gc_fireworkSmallRedProjectile)
{
  uiName = "Firework (S) Orange";
  explosion = gc_fireworkSmallOrangeExplosion;
};

datablock ProjectileData(gc_fireworkSmallYellowProjectile : gc_fireworkSmallRedProjectile)
{
  uiName = "Firework (S) Yellow";
  explosion = gc_fireworkSmallYellowExplosion;
};

datablock ProjectileData(gc_fireworkSmallGreenProjectile : gc_fireworkSmallRedProjectile)
{
  uiName = "Firework (S) Green";
  explosion = gc_fireworkSmallGreenExplosion;
};

datablock ProjectileData(gc_fireworkSmallCyanProjectile : gc_fireworkSmallRedProjectile)
{
  uiName = "Firework (S) Cyan";
  explosion = gc_fireworkSmallCyanExplosion;
};

datablock ProjectileData(gc_fireworkSmallBlueProjectile : gc_fireworkSmallRedProjectile)
{
  uiName = "Firework (S) Blue";
  explosion = gc_fireworkSmallBlueExplosion;
};

datablock ProjectileData(gc_fireworkSmallPurpleProjectile : gc_fireworkSmallRedProjectile)
{
  uiName = "Firework (S) Purple";
  explosion = gc_fireworkSmallPurpleExplosion;
};

datablock ProjectileData(gc_fireworkSmallWhiteProjectile : gc_fireworkSmallRedProjectile)
{
  uiName = "Firework (S) White";
  explosion = gc_fireworkSmallWhiteExplosion;
};

datablock ProjectileData(gc_fireworkSmallRainbow1Projectile : gc_fireworkSmallRedProjectile)
{
  uiName = "Firework (S) Rainbow 1";
  explosion = gc_fireworkSmallRainbow1Explosion;
};

datablock ProjectileData(gc_fireworkSmallRainbow2Projectile : gc_fireworkSmallRedProjectile)
{
  uiName = "Firework (S) Rainbow 2";
  explosion = gc_fireworkSmallRainbow2Explosion;
};

function gc_fireworkSmallRedProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkSmallOrangeProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkSmallYellowProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkSmallGreenProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkSmallCyanProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkSmallBlueProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkSmallPurpleProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkSmallWhiteProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkSmallRainbow1Projectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkSmallRainbow2Projectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}
